﻿/* Outlook Web Access (OWA) module for Jive Anywhere (page content script)

   PageModuleContext, JCommon and $ are provided by the module manager
*/

var jviewContainerSelector = 'div#divItmPrts,div#divConvTopic';
var lastItemUrl = null;

this.init = function (params, sendResponse) {
    checkItemUrl();
};

this.discussionClosed = function () {
    // remove jView and make default OWA container visible again
    $("#jiveAnywhereJview").remove();
    var container = $(jviewContainerSelector);
    container.show();
};

function checkItemUrl() {
    var ifRP = $('div#ifRP[url]');
    if (ifRP) {
        var url = ifRP.attr('url');
        if (lastItemUrl != url) {
            lastItemUrl = url;
            try {
                onItemChange();
            }
            catch (err) {
                //Handle errors here
            }
        }
        setTimeout(checkItemUrl, 500);
    }
}

function onItemChange() {
    // remove old jview frame if exists
    $("#jiveAnywhereJview").remove();
    var container = $(jviewContainerSelector);
    container.show();
    
    checkIfJiveMessage();
}

function checkIfJiveMessage() {
    getReplyAddress(function (replyAddress) {
        if (replyAddress) {
            // this is a Jive reply email address, parse it to get the item id and type
            var item = decodeEmail.decode(replyAddress);
            // create a stand alone jView frame
            var frame = PageModuleContext.createDiscussionViewFrame("jiveAnywhereJview", item.itemType, item.itemId);
            // hide the default OWA mail view container and append jview inside
            var container = $(jviewContainerSelector);
            container.hide();
            container.parent().append(frame);
        }
    });
}

function getReplyAddress(callback) {
    // listen hash changes event
    var canary = $('a[target]:first').attr('href').match(/\?C=(.*)&/)[1];
    //var pspid = $('div#ifRP[pspid]').attr('pspid');
    var id = $('div[sitmid]:first').attr('sitmid');
    $.ajax({
        url: "ev.owa?oeh=1&ns=ReadMessage&ev=LMD&canary=" + canary + "&Id=id%3d" + id.replace(/\//g, "%252f").replace(/\+/g, "%252b"),
        context: document.body
    }).done(function (response) {
        var match = response.match(/jive(-[A-Za-z0-9]+){4}@[A-Za-z0-9.]+/i);
        if (match && match.length > 0) {
            var replyToMail = match[0];
            callback(replyToMail);
        }
    });
}

var decodeEmail = new function () {
    // mail decode section
    var _baseChars = "0123456789abcdefghijklmnopqrstuvwxyz";
    var _oldBase = "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";
    var _charToNumber = new Array();
    var _oldCharToNumber = new Array();
    for (var i = 0; i < 256; i++) {
        _charToNumber[i] = -1;
        _oldCharToNumber[i] = -1;
    }

    var iS = _baseChars.length;
    for (i = 0; i < iS; i++) {
        _charToNumber[_baseChars.charCodeAt(i)] = i;
    }

    iS = _oldBase.length;
    for (i = 0; i < iS; i++) {
        _oldCharToNumber[_oldBase.charCodeAt(i)] = i;
    }

    var decodeAlphaNumeric = function (str) {
        var result = 0;
        if (str != "0") {
            var tmpBase = _baseChars;
            var tmpIndexes = _charToNumber;
            if (!str.toLowerCase() == str) {
                tmpBase = _oldBase;
                tmpIndexes = _oldCharToNumber;
            }
            for (var i = 0; i < str.length; i++) {
                var current = str.charCodeAt(str.length - 1 - i);
                var currentVal = tmpIndexes[current];
                result += currentVal * Math.pow(tmpBase.length, i);
            }
        }
        return result;
    };

    this.decode = function (email) {
        var data = null;
        if (email) {
            var replyParts = email.split('@');
            if (replyParts.length == 2) {
                var fullId = replyParts[0];
                var parts = fullId.split('-');
                if (parts.length == 5) {
                    data = new Object();
                    data.prefix = parts[0];
                    data.randomToken = decodeAlphaNumeric(parts[1]);
                    data.userId = decodeAlphaNumeric(parts[2]);
                    data.itemType = decodeAlphaNumeric(parts[3]);
                    data.itemId = decodeAlphaNumeric(parts[4]);
                }
            }
        }
        return data;
    };
}